       external equation
       double precision t,tout,y(3)
       double precision relerr,abserr
       double precision step 
       integer iflag
       integer nsteps
       integer i
       integer ans
       
       double precision work(250)
       integer iwork(50)
       double precision rho, sigma, beta
       common rho,sigma,beta

       rho = 28.0
       sigma = 10.0
       beta = 8.0/3.0
       
       y(1)  = 1
       y(2)  = 0.99
       y(3)  = 1.999
       relerr = 1.0e-7
       abserr = 1.0e-7 
       step  = 0.01
       nsteps = 10000

       iflag = 1
       t=0.0d0

       do 10 i=1,nsteps
       tout = t + step
       call rkf45(equation,3,y,t,tout,relerr,abserr,iflag,work,iwork)
       t = tout

       if ( iflag .eq. 2) then 
c         integration reached tout. indicates successful return
c         and is the normal mode for continuing integration.
       goto  100
       endif
       if ( iflag .eq. -2) then 
c         a single successful step in the direction of tout
c         has been taken. normal mode for continuing
c         integration one step at a time.
       goto  100
       endif
       if ( iflag .eq. 3) then 
       write(*,*)'integration was not completed because relative error'
       write(*,*)'tolerance was too small. relerr has been increased'
       write(*,*)'appropriately for continuing.'
       goto  100
       endif
       if ( iflag .eq. 4 )then
c      write(*,*)'integration was not completed because more than'
c      write(*,*)'3000 derivative evaluations were needed. this'
c      write(*,*)'is approximately 500 steps.'
       iflag = 2 
       endif
       if ( iflag .eq. 5) then
       write(*,*)'integration was not completed because solution'
       write(*,*)'vanished making a pure relative error test'
       write(*,*)'impossible. must use non-zero abserr to continue.'
       write(*,*)'using the one-step integration mode for one step'
       write(*,*)'is a good way to proceed.'
       stop
       endif
       if ( iflag .eq. 6) then
       write(*,*)'integration was not completed because requested'
       write(*,*)'accuracy could not be achieved using smallest'
       write(*,*)'allowable stepsize. user must increase the error'
       write(*,*)'tolerance before continued integration can be'
       write(*,*)'attempted.'
       stop
       endif
       if ( iflag .eq. 7) then
c       write(*,*)'it is likely that rkf45 is inefficient for solving'
c       write(*,*)'this problem. too much output is restricting the'
c       write(*,*)'natural stepsize choice. use the one-step integrator'
c       write(*,*)'mode.'
       iflag = 2
	goto 100
       stop
       endif
       if ( iflag .eq. 8) then
       write(*,*)'invalid input parameters'
       write(*,*)'this indicator occurs if any of the following is'
       write(*,*)'satisfied -   neqn .le. 0'
       write(*,*)'t=tout  and  iflag .ne. +1 or -1'
       write(*,*)'relerr or abserr .lt. 0.'
       write(*,*)'iflag .eq. 0  or  .lt. -2  or  .gt. 8'
       stop
       endif
100    continue
       write(*,*) tout,y(1),y(2),y(3)
10     continue
C 101    format( f20.11,2x,f20.11, 2x, f20.11, 2x, f20.11)
       stop
       end

       subroutine equation(t,y,yp)
       double precision t,y(3),yp(3)
       double precision rho, sigma, beta
       common rho,sigma, beta

       yp(1) = sigma*(y(2) -y(1))
       yp(2) = y(1)*(rho - y(3) )- y(2) 
       yp(3) = y(1)*y(2) - beta*y(3)
       return
       end
